﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;

namespace WifiLocator
{
    class Door
    {

        public Door(int x1, int y1, int xc, int yc, int x2, int y2) {
            this.Point1 = new Point(x1, y1);
            this.Point2 = new Point(x2, y2);
            this.PointCenter = new Point(xc, yc);
        }

        public Point Point1 { get; set; }

        public Point Point2 { get; set; }

        public Point PointCenter { get; set; }
    
        public void display(Canvas canvas, double meritko, double posunX, double posunY)
        {
            //line 1
            Line line = new Line();
            BrushConverter bc = new BrushConverter();
            line.Stroke = Brushes.Black;
            line.StrokeThickness = 3 * meritko;
            line.X1 = (Point1.X * meritko) + posunX;
            line.X2 = (PointCenter.X * meritko) + posunX;
            line.Y1 = (Point1.Y * meritko) + posunY;
            line.Y2 = (PointCenter.Y * meritko) + posunY;
            canvas.Children.Add(line);

            //line 2
            line = new Line();
            line.Stroke = Brushes.Black;
            line.StrokeThickness = 3 * meritko;
            line.X1 = (Point2.X * meritko) + posunX;
            line.X2 = (PointCenter.X * meritko) + posunX;
            line.Y1 = (Point2.Y * meritko) + posunY;
            line.Y2 = (PointCenter.Y * meritko) + posunY;
            canvas.Children.Add(line);

            //arc
            var g = new StreamGeometry();

            using (var gc = g.Open())
            {
                gc.BeginFigure(
                    startPoint: new System.Windows.Point((Point1.X * meritko) + posunX, (Point1.Y * meritko) + posunY),
                    isFilled: false,
                    isClosed: false);

                SweepDirection direction = SweepDirection.Clockwise;

                gc.ArcTo(
                    point: new System.Windows.Point((Point2.X * meritko) + posunX, (Point2.Y * meritko) + posunY),
                    size: new Size(Math.Abs((Point1.X - Point2.X) * meritko), Math.Abs((Point1.Y - Point2.Y) * meritko)),
                    rotationAngle: 0d,
                    isLargeArc: false,
                    sweepDirection: direction,
                    isStroked: true,
                    isSmoothJoin: false);
            }

            var path = new Path
            {
                Stroke = Brushes.Black,
                StrokeThickness = 2 * meritko,
                Data = g
            };

            canvas.Children.Add(path);
        }
    }
}
