﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WifiLocator
{
    public class PointGroup
    {

        //tolerance prirazeni bodu do skupiny v cm
        private int tolerance = 500;

        private List<Point> points = new List<Point>();

        public bool Add(Point point) {
            if (points.Count == 0 || this.canBeAdd(point))
            {
                points.Add(point);
                return true;
            }
            return false;
        }

        public Point getAverangePoint() {
            if (points.Count == 0)
                return null;
            int x = 0;
            int y = 0;
            foreach (Point p in points) {
                x += p.X;
                y += p.Y;
            }
            x = (int)Math.Round((decimal)(x / points.Count));
            y = (int)Math.Round((decimal)(y / points.Count));
            return new Point(x, y);
        }

        public int getCount() {
            return points.Count;
        }

        private bool canBeAdd(Point p) {
            Point ap = getAverangePoint();
            if (p.X > ap.X - tolerance && p.X < ap.X + tolerance && p.Y > ap.Y - tolerance && p.Y < ap.Y + tolerance)
                return true;
            return false;
        }

    }
}
