﻿using System;
using System.Net;
using System.Windows;

namespace WifiLocator
{
    /// <summary>
    /// Interaction logic for SettingWindow.xaml
    /// </summary>
    public partial class SettingWindow : Window
    {
        public SettingWindow()
        {
            InitializeComponent();
            IPHostEntry ipHostInfo = Dns.GetHostEntry(Dns.GetHostName());
            foreach (IPAddress ip in ipHostInfo.AddressList)
            {
                inputIP.Items.Add(ip.ToString());
            }
        }

        public void setInputIP(IPAddress ip) {
            if (ip != null)
                inputIP.SelectedItem = ip.ToString();
        }

        private void btnSave_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                Int32 port = Int32.Parse(inputPort.Text);
                ((MainWindow)this.Owner).setPort(port);
                ((MainWindow)this.Owner).setIP(IPAddress.Parse(inputIP.Text));
                ((MainWindow)this.Owner).restartServer();
                this.Close();
            }
            catch{
                MessageBox.Show("IP adresa a port musí mít správný formát!","Chyba",MessageBoxButton.OK,MessageBoxImage.Error);
            }
        }
    }
}
