﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WifiLocator
{
    public class SignalMap
    {

        private int meritko = 100;

        public SignalMap(string m, int w, int h) {
            this.Mac = m;
            this.Width = w;
            this.Height = h;

            //vypocet velikosti pole (v metrech)
            decimal x = w / meritko;
            int aw = (int)Decimal.Round(x);
            decimal y = h / meritko;
            int ah = (int)Decimal.Round(y);
            //inicializace pole
            this.Signals = new int[aw, ah];
            this.lockSignals = new int[aw, ah];
            //naplceni pole nulovymi hodnotami
            for (int a = 0; a < aw; a++) {
                for (int b = 0; b < ah; b++) {
                    Signals[a, b] = 0;
                    lockSignals[a, b] = 0;
                }
            }
            Console.WriteLine("----------------------------");
            Console.WriteLine("New signal map ({0},{1})",aw.ToString(), ah.ToString());
        }

        public void setSignal(int ix, int iy, int s) {
            decimal x = ix / meritko;
            int ax = (int)Decimal.Round(x)-1;
            decimal y = iy / meritko;
            int ay = (int)Decimal.Round(y)-1;
            if (ax < 0)
                ax = 0;
            if (ay < 0)
                ay = 0;
            Signals[ax, ay] = s;
            lockSignals[ax, ay] = 1;
            Console.WriteLine("New locked signal: ({0},{1}) -> {2}) => {3};{4}",ix.ToString(), iy.ToString(), s.ToString(),ax.ToString(),ay.ToString());
        }

        public bool calculateSignals() {
            Console.WriteLine("Calculating signals..");

            int zmena = 0;
            int cyklus = 0;
            int maxCyklus = 100;

            do
            {
                zmena = 0;
                cyklus++;
                for (int x = 0; x < Signals.GetLength(0); x++)
                {
                    for (int y = 0; y < Signals.GetLength(1); y++)
                    {
                        if (lockSignals[x, y] == 0)
                        {
                            // vzorec
                            // y = -0,0144x^3 + 0,5416x^2 - 6,887x - 11,427


                            int newsignal = 0;
                            int count = 0;

                            //vodorovne
                            int cisloL = 0;
                            int cisloR = 0;
                            int pocetL = 0;
                            int pocetR = 0;

                            if (y > 0)
                            {
                                for (int y2 = y; y2 >= 0; y2--)
                                {
                                    pocetL++;
                                    if (Signals[x, y2] != 0)
                                    {
                                        cisloL = Signals[x, y2];
                                        break;
                                    }
                                }
                                if (cisloL == 0)
                                    pocetL = 0;
                            }

                            if (y < Signals.GetLength(1))
                            {

                                for (int y2 = y; y2 < Signals.GetLength(1); y2++)
                                {
                                    pocetR++;
                                    if (Signals[x, y2] != 0)
                                    {
                                        cisloR = Signals[x, y2];
                                        break;
                                    }
                                }
                                if (cisloR == 0)
                                    pocetR = 0;
                            }

                            if (cisloL > 0 && cisloR > 0)
                            {
                                int c = ((cisloL - cisloR) / (pocetL + pocetR)) * pocetR + cisloR;
                                if (c > 0)
                                {
                                    newsignal += c;
                                    count++;
                                }

                            }

                            //svisle
                            int cisloU = 0;
                            int cisloD = 0;
                            int pocetU = 0;
                            int pocetD = 0;

                            if (x > 0)
                            {
                                for (int x2 = x; x2 >= 0; x2--)
                                {
                                    pocetU++;
                                    if (Signals[x2, y] != 0)
                                    {
                                        cisloU = Signals[x2, y];
                                        break;
                                    }
                                }
                                if (cisloU == 0)
                                    pocetU = 0;
                            }

                            if (x < Signals.GetLength(0) - 1)
                            {
                                for (int x2 = x; x2 < (Signals.GetLength(0)); x2++)
                                {
                                    pocetD++;
                                    if (Signals[x2, y] != 0)
                                    {
                                        cisloD = Signals[x2, y];
                                        break;
                                    }
                                }
                                if (cisloD == 0)
                                    pocetD = 0;
                            }

                            if (cisloU > 0 && cisloD > 0)
                            {
                                int c = ((cisloU - cisloD) / (pocetU + pocetD)) * pocetD + cisloD;
                                if (c > 0)
                                {
                                    newsignal += c;
                                    count++;
                                }
                            }

                            //sikmo LR
                            cisloL = 0;
                            cisloR = 0;
                            pocetL = 0;
                            pocetR = 0;
                            int x3 = 0;
                            if (x > 0 && y > 0)
                            {
                                x3 = x;
                                for (int y2 = y; y2 >= 0; y2--)
                                {
                                    pocetL++;
                                    if (Signals[x3, y2] != 0)
                                    {
                                        cisloL = Signals[x3, y2];
                                        break;
                                    }
                                    x3--;
                                    if (x3 < 0)
                                        break;
                                }
                                if (cisloL == 0)
                                    pocetL = 0;
                            }

                            if (x < Signals.GetLength(0) && y < Signals.GetLength(1))
                            {
                                x3 = x;
                                for (int y2 = y; y2 < Signals.GetLength(1); y2++)
                                {
                                    pocetR++;
                                    if (Signals[x3, y2] != 0)
                                    {
                                        cisloR = Signals[x3, y2];
                                        break;
                                    }
                                    x3++;
                                    if (x3 >= Signals.GetLength(0))
                                        break;
                                }
                                if (cisloR == 0)
                                    pocetR = 0;
                            }

                            if (cisloL > 0 && cisloR > 0)
                            {
                                int c = ((cisloL - cisloR) / (pocetL + pocetR)) * pocetR + cisloR;
                                if (c > 0)
                                {
                                    newsignal += c;
                                    count++;
                                }

                            }

                            //sikmo RL
                            cisloL = 0;
                            cisloR = 0;
                            pocetL = 0;
                            pocetR = 0;
                            x3 = 0;
                            if (x < Signals.GetLength(0) && y > 0)
                            {
                                x3 = x;
                                for (int y2 = y; y2 >= 0; y2--)
                                {
                                    pocetL++;
                                    if (Signals[x3, y2] != 0)
                                    {
                                        cisloL = Signals[x3, y2];
                                        break;
                                    }
                                    x3++;
                                    if (x3 >= Signals.GetLength(0))
                                        break;
                                }
                                if (cisloL == 0)
                                    pocetL = 0;
                            }

                            if (x > 0 && y < Signals.GetLength(1))
                            {
                                x3 = x;
                                for (int y2 = y; y2 < Signals.GetLength(1); y2++)
                                {
                                    pocetR++;
                                    if (Signals[x3, y2] != 0)
                                    {
                                        cisloR = Signals[x3, y2];
                                        break;
                                    }
                                    x3--;
                                    if (x3 < 0)
                                        break;
                                }
                                if (cisloR == 0)
                                    pocetR = 0;
                            }

                            if (cisloL > 0 && cisloR > 0)
                            {
                                int c = ((cisloL - cisloR) / (pocetL + pocetR)) * pocetR + cisloR;
                                if (c > 0)
                                {
                                    newsignal += c;
                                    count++;
                                }

                            }

                            //vypocet suma

                            if (count > 0)
                            {
                                double z = (newsignal / count);
                                newsignal = (int)Math.Round(z, 0);
                                if (newsignal != Signals[x, y])
                                {
                                    Signals[x, y] = newsignal;
                                    zmena++;
                                }
                            }
                        }
                    }
                }
            } while (zmena > 0 && cyklus <= maxCyklus);

            if (zmena == 0)
            {
                Console.WriteLine("Calculating done.. ({0} cykles)",cyklus);
                for (int x = 0; x < Signals.GetLength(0); x++)
                {
                    for (int y = 0; y < Signals.GetLength(1); y++)
                    {
                        Console.Write("{0}\t", Signals[x,y]);
                    }
                    Console.Write("\n");
                }
                return true;
            }
            else
            {
                Console.WriteLine("Calculating error..");
                return false;
            }
        }

        public List<Point> getPoints(int strenght, int tolerance = 0) {
            List<Point> pl = new List<Point>();
            for (int x = 0; x < Signals.GetLength(0); x++)
            {
                for (int y = 0; y < Signals.GetLength(1); y++)
                {
                    if (Signals[x, y] >= strenght - tolerance && Signals[x, y] <= strenght + tolerance) {
                        pl.Add(new Point(x*meritko,y*meritko));
                    }
                }
            }
            return pl;
        }

        public int Width { get; set; }
        public int Height { get; set; }
        public string Mac { get; set; }
        public int[,] Signals { get; set; }
        public int[,] lockSignals { get; set; }
        
    }
}
