﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;

namespace WifiLocator
{
    public class Text : Shape
    {

        public Text()
        {
            this.Content = "Text";
            this.X = 0;
            this.Y = 0;
            this.Color = Color.FromRgb(0, 0, 0);
            this.Size = 16;
            this.FontWeight = FontWeights.Normal;
        }

        public string Content { get; set; }
        public double X { get; set; }
        public double Y { get; set; }
        public Color Color { get; set; }
        public double Size { get; set; }
        public FontWeight FontWeight { get; set; }

        protected override
           Geometry DefiningGeometry
        {
            get { return Geometry.Empty; }
        }
        protected override void OnRender
           (DrawingContext drawingContext)
        {
            FormattedText ft = new FormattedText
               (Content, new CultureInfo("cz-cs"),
               FlowDirection.LeftToRight,
               new Typeface(
                  new FontFamily("Arial"),
                  FontStyles.Normal,
                  FontWeight,
                  new FontStretch()),
               Size,
               new SolidColorBrush(Color));
            drawingContext.DrawText
               (ft, new System.Windows.Point(Convert.ToInt32(X), Convert.ToInt32(Y)));
            //base.OnRender(drawingContext);
        }
    }
}
