﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WifiSignalMeter
{

    public partial class Form1 : Form
    {

        bool listening = false;

        private IPAddress ip = IPAddress.Any;
        private int port = 11000;
        private string hmac = "00:0e:2e:ef:78:1f";
        Thread tcpServerRunThread;
        Thread tcpHandlerThread;
        List<TcpClient> clients = new List<TcpClient>();
        List<NetworkStream> streams = new List<NetworkStream>();

        int smin = 1000;
        int smax = 0;
        int snow = 0;


        public Form1()
        {
            InitializeComponent();
            IPHostEntry ipHostInfo = Dns.GetHostEntry(Dns.GetHostName());
            foreach (IPAddress ip in ipHostInfo.AddressList)
            {
                ipaddrlist.Items.Add(ip.ToString());
            }
            signalMin.Text = "- dB";
            signalNow.Text = "- dB";
            signalMax.Text = "- dB";
            signalTime.Text = "nikdy";

            liseningIndicator.ForeColor = Color.Red;
            liseningIndicator.Value = 0;
        }

        private void TcpServerRun() {
            TcpListener tcplistener = new TcpListener(ip, port);
            tcplistener.Start();

            while (true) {
                TcpClient client = tcplistener.AcceptTcpClient();
                clients.Add(client);
                Func<int> del = delegate () {
                    datareciveIndicator.Value = 1;
                    return 0;
                };
                tcpHandlerThread = new Thread(new ParameterizedThreadStart(TcpHandler));
                tcpHandlerThread.IsBackground = true;
                tcpHandlerThread.Start(client);
                Invoke(del);
            }
        }

        private void TcpHandler(object client) {
            TcpClient mClient = (TcpClient)client;
            NetworkStream stream = mClient.GetStream();
            streams.Add(stream);
            while (true)
            {
                byte[] msg = new byte[1024];
                stream.Read(msg, 0, msg.Length);
                string s = Encoding.ASCII.GetString(msg);
                s = Regex.Replace(s, @"\0", "");
                updateUI(s);//Encoding.ASCII.GetString(msg));
            }
        }

        private void updateUI(string s) {
            Func<int> del = delegate () {
                Regex reg = new Regex(@"^(\d)+\[([^\]]+)\]$", RegexOptions.IgnoreCase);
                Match m = reg.Match(s);
                if (m.Success)
                {
                    GroupCollection g = m.Groups;
                    wifiId.Text = g[1].Value;
                    string[] data = g[2].Value.Split(';');
                    foreach (string hotspot in data) {
                        Regex reg2 = new Regex(@"^([^\(]+)\(([^\)]+)\)");
                        Match m2 = reg2.Match(hotspot);
                        if (m2.Success)
                        {
                            GroupCollection g2 = m2.Groups;
                            string[] info = g2[2].Value.Split(',');
                            if (info[2] == hmac) {
                                int signal = int.Parse(info[1]);
                                if (Math.Abs(signal) < Math.Abs(smin))
                                {
                                    smin = signal;
                                    signalMin.Text = smin.ToString();
                                }
                                if (Math.Abs(signal) > Math.Abs(smax)) {
                                    smax = signal;
                                    signalMax.Text = smax.ToString();
                                    signalBar.Maximum = Math.Abs(smax);
                                }
                                snow = signal;
                                signalNow.Text = signal.ToString();
                                signalBar.Value = Math.Abs(signal);
                            }
                        }
                    }
                }
                else {
                    wifiId.Text = "Bad MSG";
                }
                signalTime.Text = DateTime.Now.ToString("HH:mm:ss");
                return 0;
            };
            try
            {
                Invoke(del);
            }
            catch (Exception e){
            }
        }

        public int listeningInd {
            get {
                return liseningIndicator.Value;
            }
            set {
                liseningIndicator.Value = value;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (!listening && inputPort.Text.Length > 0 && inputMac.Text.Length > 0)
            {
                listening = true;
                if (ipaddrlist.Text.Length > 0)
                {
                    ip = IPAddress.Parse(ipaddrlist.Text);
                }
                else {
                    ip = IPAddress.Any;
                }
                hmac = inputMac.Text;
                port = int.Parse(inputPort.Text);
                startButton.Text = "Running..";
                listeningInd = 1;
                tcpServerRunThread = new Thread(new ThreadStart(TcpServerRun));
                tcpServerRunThread.IsBackground = true;
                tcpServerRunThread.Start();
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            String txt = inputdistance.Text;
            float distance = float.Parse(txt);
            distance += 1;
            inputdistance.Text = distance.ToString();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            String txt = inputdistance.Text;
            float distance = float.Parse(txt);
            distance -= 1;
            if (distance < 0)
                distance = 0;
            inputdistance.Text = distance.ToString();
        }

        private void dataSaveBtn_Click(object sender, EventArgs e)
        {
            DataGridViewRow row = (DataGridViewRow)dataTable.Rows[0].Clone();
            row.Cells[0].Value = inputdistance.Text;
            row.Cells[1].Value = snow;
            dataTable.Rows.Add(row);
        }

        private void exportButton_Click(object sender, EventArgs e)
        {
            saveFileDialog1.Filter = "CSV file | *.csv";
            saveFileDialog1.ShowDialog();
            string filecontent = "";
            foreach (DataGridViewRow row in dataTable.Rows) {
                if(!row.IsNewRow && row.Cells.Count > 0)
                {
                    string d = row.Cells[0].Value.ToString();
                    string s = row.Cells[1].Value.ToString();
                    filecontent += d + ";" + s + ";\n";
                }
            }
            try
            {
                if (File.Exists(saveFileDialog1.FileName))
                {
                    File.Delete(saveFileDialog1.FileName);
                }

                // Create the file.
                using (FileStream fs = File.Create(saveFileDialog1.FileName))
                {
                    Byte[] info = new UTF8Encoding(true).GetBytes(filecontent);
                    fs.Write(info, 0, info.Length);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }
    }
}